# -*- rpm-spec -*-
#===============================================================================
#
# GRANULE spec.in file.
#
# RPM format: name-version-release.rpm
#
# $Id: granule.spec.in,v 1.9 2004/07/22 12:10:04 vlg Exp $
#===============================================================================
%define name            granule
%define ver             1.1.0
%define rel             0
%define debug_package   %{nil}

%define prefix          /usr
%define datadir         /usr/share
%define xmldir          /etc/xml/%{name}

Summary:    granule
Name:       %name
Version:    %ver
Release:    %rel
Source:     %{name}-%{version}.tar.gz
Copyright:  GPL
Group:      Applications
Packager:	Vladislav Grinchenko (vlg@users.sourceforge.net)
Source: 	%{name}-%{version}.tar.gz
URL:        http://granule.sourceforge.net/
Prefix: 	/usr
BuildRoot:  /var/tmp/%{name}-%{version}-root

%description 
granule is a flashcard program that implements Leither cardfile
methodology for learing new words. It features both short-term and
long-term memory training capabilities with scheduling.

#===============================================================================
# preparation section
#===============================================================================

%prep
%setup

#===============================================================================
# build section
#===============================================================================

%build
%configure
if [ "$SMP" != "" ]; then
	make -j$SMP "MAKE=make -j$SMP"
else
	make
fi

#===============================================================================
# install section
#===============================================================================

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
make DESTDIR=$RPM_BUILD_ROOT install

#===============================================================================
# clenup section
#===============================================================================

%clean
rm -rf $RPM_BUILD_ROOT

#===============================================================================
# files that go into libassa package
#===============================================================================

%files
%defattr(-,root,root)

%doc COPYING AUTHORS README ChangeLog NEWS INSTALL 

%{prefix}/bin/*
%{datadir}/pixmaps/*
%{datadir}/applications/granule.desktop
%{datadir}/granule/*/*
%{datadir}/granule/*
%{xmldir}/*

#===============================================================================

%changelog
* Fri Jul 23 2004 Vladislav Grinchenko (vlg@users.sourceforge.net) - 1.1.0
- Port to gtkmm2-2.4.x
- DeckPlayer toolbar changes to UIManager/Action paradigm.
- Properly registers SayIt application icon with IconFactory.
- Adds Drag-n-Drop of a Deck for DeckList into CardBox.
- Fixes duplicate entry of the Answer field into the Example field of a Card.
- Converts FileSelection to FileChooser dialog (new in Gtk 2.4).
- Converts Box menu entries to UIManager/Action paradigm.
- Adds right-click menu for a entry in a DeckList.

* Sat Jun 26 2004 Vladislav Grinchenko <vladg@erols.com> - 1.0.2
- Fixes scheduling count/lights.
- Fixes duplicate Decks in DeckList.
- Adds DeckView activation of a Deck from DeckList in the MainWindow.
- Sets expiration date for CardBox 1 to 4 days in default config file.

* Sat Jun 12 2004 Vladislav Grinchenko <vlg@users.sourceforge.net> - 1.0.1
- Fixes tar.gz/rpm build from a wrong CVS tree.
- Changes XML DTD file location from $prefix/share/granule/xml
  to /etc/xml/granule. This way no matter how package is built,
  both Deck and CardFile files will find the DTD files. 
  This breaks all decks and cardfiles created with 1.0.0 version.
  The fix for this unfortunately requires manual editing each .dkf and
  .cdf file and replacing "/path/to/{granule|cardfile}.dtd" with
  "/etc/xml/granule/{granule|cardfile}.dtd".
- Blocks off Esc key event in CardView window.
- Adds (missing) 'bootstrap' shell script to $src directory.
- Adds front column sorting to the DeckView window.
- Fixes bogus notification pop-up when none of the CardBox cards
  are expired.

* Thu Jun  3 2004 Vladislav Grinchenko <vlg@users.sourceforge.net> - 1.0.0
- Initial release.

