// -*- c++ -*-
// generated by glade--
//------------------------------------------------------------------------------
// $Id: GeneralPref.cpp,v 1.3 2004/07/06 04:34:23 vlg Exp $
//------------------------------------------------------------------------------
//                            GeneralPref.cpp
//------------------------------------------------------------------------------
//  Copyright (c) 2004 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Sun May 30 21:09:23 EDT 2004
//
//------------------------------------------------------------------------------

#include <gtkmm/label.h>
#include <gtkmm/frame.h>

#include "Granule-main.h"
#include "Config.h"
#include "PrefWindow.h"
#include "GeneralPref.h"

GeneralPref::
GeneralPref (PrefWindow& pwin_) : 
	Gtk::VBox (false, 0),
	m_pref_window (pwin_)
{  
	trace_with_mask("GeneralPref::GeneralPref",GUITRACE);

	Gtk::Label *font_lbl      = Gtk::manage(new Gtk::Label("Font: "));
	Gtk::Frame *options_frame = Gtk::manage(new Gtk::Frame());

	m_font_entry       = Gtk::manage(new Gtk::Entry());
	m_font_button      = Gtk::manage(new Gtk::Button("Select"));
	m_font_hbox        = Gtk::manage(new Gtk::HBox(false, 0));
	m_dup_checkbutton  = Gtk::manage(new Gtk::CheckButton("Remove duplicates"));
	Gtk::Label* label5 = Gtk::manage(new Gtk::Label(""));
   
	font_lbl->set_alignment(0.5,0.5);
	font_lbl->set_padding(0,0);
	font_lbl->set_justify(Gtk::JUSTIFY_LEFT);
	font_lbl->set_line_wrap(false);
	font_lbl->set_use_markup(false);
	font_lbl->set_selectable(false);

	m_font_entry->set_flags(Gtk::CAN_FOCUS);
	m_font_entry->set_visibility(true);
	m_font_entry->set_editable(true);
	m_font_entry->set_max_length(0);
	m_font_entry->set_text("");
	m_font_entry->set_has_frame(true);
	m_font_entry->set_activates_default(false);

	m_font_button->set_flags(Gtk::CAN_FOCUS);
	m_font_button->set_relief(Gtk::RELIEF_NORMAL);

	m_font_hbox->set_border_width(1);
	m_font_hbox->pack_start(*font_lbl, Gtk::PACK_SHRINK, 0);
	m_font_hbox->pack_start(*m_font_entry, Gtk::PACK_EXPAND_WIDGET, 3);
	m_font_hbox->pack_start(*m_font_button, Gtk::PACK_SHRINK, 2);

	m_dup_checkbutton->set_flags(Gtk::CAN_FOCUS);
	m_dup_checkbutton->set_relief(Gtk::RELIEF_NORMAL);
	m_dup_checkbutton->set_mode(true);
	m_dup_checkbutton->set_active(false);

	label5->set_alignment(0.5,0.5);
	label5->set_padding(0,0);
	label5->set_justify(Gtk::JUSTIFY_LEFT);
	label5->set_line_wrap(false);
	label5->set_use_markup(false);
	label5->set_selectable(false);

	options_frame->set_shadow_type(Gtk::SHADOW_ETCHED_IN);
	options_frame->set_label_align(0,0.5);
	options_frame->add(*m_dup_checkbutton);
	options_frame->set_label_widget(*label5);

	set_border_width(14);

	pack_start(*m_font_hbox, Gtk::PACK_SHRINK, 4);
	pack_start(*options_frame, Gtk::PACK_SHRINK, 0);

	m_font_entry->signal_changed().connect (
		sigc::mem_fun (m_pref_window, &PrefWindow::changed_cb));
	m_dup_checkbutton->signal_toggled().connect (
		sigc::mem_fun (m_pref_window, &PrefWindow::changed_cb));

	m_font_button->signal_clicked().connect (
		sigc::mem_fun (*this, &GeneralPref::on_select_clicked));

	font_lbl->show();
	m_font_entry->show();
	m_font_button->show();
	m_font_hbox->show();
	m_dup_checkbutton->show();
	label5->show();
	options_frame->show();
}

void
GeneralPref::
changed_cb () 
{
	m_pref_window.changed ();
}

void
GeneralPref::
load_from_config ()
{
	trace_with_mask("GeneralPref::load_from_config",GUITRACE);

	m_font_entry->set_text (CONFIG->get_font ().to_string ());
	m_dup_checkbutton->set_active (CONFIG->get_remove_duplicates ());
}

void
GeneralPref::
save_to_config ()
{
	trace_with_mask("GeneralPref::save_to_config",GUITRACE);

	CONFIG->set_font (m_font_entry->get_text ());
	CONFIG->set_remove_duplicates (m_dup_checkbutton->get_active ());
}

void
GeneralPref::
on_select_clicked ()
{
	trace_with_mask("GeneralPref::on_select_clicked",GUITRACE);

	Gtk::FontSelectionDialog sfd ("Select Text Font");
	sfd.set_font_name (m_font_entry->get_text ());

	if (sfd.run () != Gtk::RESPONSE_OK) {
		return;
	}
	m_font_entry->set_text (sfd.get_font_name ());
	DL((GRAPP,"Text font changed : \"%s\"\n", 
		m_font_entry->get_text ().c_str ()));
}
