// -*- c++ -*-
//------------------------------------------------------------------------------
// $Id: PrefWindow.cpp,v 1.2 2004/06/01 03:52:28 vlg Exp $
//------------------------------------------------------------------------------
//                            PrefWindow.h
//------------------------------------------------------------------------------
//  Copyright (c) 2004 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Sun May 30 21:09:23 EDT 2004
//
//------------------------------------------------------------------------------

#include "Config.h"
#include "PrefWindow.h"

PrefWindow::
PrefWindow () :
    MyPropertyBox ("Preferences"),
	m_general_pref (*this),
	m_scheduling_pref (*this),
	m_sound_pref (*this),
	m_ignore_callbacks (true),
	m_changed (false)
{
    trace_with_mask("PrefWindow::PrefWindow",GUITRACE);

	/** Show all
	 */
	m_general_pref.show_all ();
	m_scheduling_pref.show_all ();
	m_sound_pref.show_all ();
	
	/** Pack all
	 */
	append_page (m_general_pref,    "General");
	append_page (m_scheduling_pref, "Scheduling");
	append_page (m_sound_pref,      "Sound");
}

bool
PrefWindow::
run ()
{
    trace_with_mask("PrefWindow::run",GUITRACE);

	m_ignore_callbacks = true;	
    m_changed = false;

	/** Fill values of all pages with fresh values from Config
	 */
	m_general_pref.load_from_config ();
	m_scheduling_pref.load_from_config ();
	m_sound_pref.load_from_config ();
	
	m_ignore_callbacks = false;
	m_apply_button->set_sensitive (false);

    show ();
    Gtk::Main::run ();
    return m_changed;
}

void 
PrefWindow::
apply_impl ()
{
    trace_with_mask("PrefWindow::apply_impl",GUITRACE);

	m_general_pref.save_to_config ();
	m_scheduling_pref.save_to_config ();
	m_sound_pref.save_to_config ();
}
