// -*- c++ -*-
//------------------------------------------------------------------------------
//                              VCard.h
//------------------------------------------------------------------------------
// $Id: VCard.h,v 1.4 2004/05/26 22:15:47 vlad Exp $
//
// Date: Apr 24 2004
//------------------------------------------------------------------------------
#ifndef VCARD_H
#define VCARD_H

#include <string>
using std::string;

#include <glibmm/ustring.h>
using Glib::ustring;

#include <assa/TimeVal.h>

class VCard 
{
public:
	VCard () : m_dirty (false) { /* no-op */ }
	virtual ~VCard () { /* no-op */ }

	virtual void set_question (const ustring& q_) = 0;
	virtual void set_answer   (const ustring& a_) = 0;
	virtual void set_example  (const ustring& e_) = 0;

	virtual ustring get_question () const = 0;
	virtual ustring get_answer   () const = 0;
	virtual ustring get_example  () const = 0;
	virtual long    get_id       () const = 0;

	virtual void set_expiration (const ASSA::TimeVal&) { /* no-op */ }
	virtual ASSA::TimeVal get_expiration () const;

	void mark_dirty   () { m_dirty = true; }
	void mark_clean   () { m_dirty = false; }
	bool is_dirty     () const { return m_dirty; }
	string get_id_str ();

	virtual void dump () const = 0;

protected:
	bool m_dirty;
};

inline ASSA::TimeVal VCard::get_expiration () const
{
	return (ASSA::TimeVal (0));
}

#endif /* VCARD_H */
